#include <stdbool.h>
#include <serial.h>
#include <printf.h>
#include <paging.h>
#include <video.h>
#include <acpi.h>

void panic() { // will fill with debugging info latter
  printf("Kernel panic!\n");
  for(;;);
}


void main() {
  if(!(init_serial(COM1))) {
    printf("\nKernal started on CPU 1!\n"); // will detect cpu later
  }
  
  rsdp_t *rsdp;
  rsdp = find_RSDP();
  if(!(rsdp)) {
    printf("Couldn't find the RSDP... not sure what to do now.\n");
    panic();
  }


  dump_video();
  debug_print_memory();

  init_memory();

  panic();

}
